\documentclass[titlepage,a4paper]{article}

\usepackage[utf8]{inputenc}
\usepackage[T1]{fontenc}

% Selection de la langue
%--------------------------------------------------------------------------

\usepackage[english, shorthands=off]{babel}
\selectlanguage{english}

% Titre, auteur, matière et date
%--------------------------------------------------------------------------

\newcommand{\titre}{Internship report} 
\newcommand{\Universite}{Université de Bordeaux}
\newcommand{\auteur}{MARIE Nathanaël}
\newcommand{\tuteur}{Tutor: BELOUARGA Mohamed}
\newcommand{\matiere}{End-of-study internship - Open Portable Trusted Execution Environment)}
\newcommand{\cursus}{Master 2 - Computer Science (ASPIC)}
\newcommand{\TnS}{T\&S}
\newcommand{\ville}{Bordeaux}
\newcommand{\ajd}{\today}

% Paquete para generar texto de relleno. Se puede eliminar
%--------------------------------------------------------------------------

\usepackage{lipsum}
\usepackage{csquotes}
\usepackage{svg}
\usepackage[
    %backend=biber, 
    natbib=true,
    style=numeric,
    sorting=none,
]{biblatex}
\addbibresource{ref_report.bib} %Import the bibliography file
\usepackage{parskip}
\usepackage{enumitem}

\newlist{notes}{enumerate}{1}
\setlist[notes]{label=\textbf{Note:} ,leftmargin=*}

% Dimensiones de página
%--------------------------------------------------------------------------

\usepackage[a4paper,includeheadfoot,margin=2.54cm]{geometry}

% Paquetes de la AMS
%--------------------------------------------------------------------------

\usepackage{amsmath}
\usepackage{amsfonts}
\usepackage{amssymb}
\usepackage{amsthm}


% Paquetes de símbolos usuales y de formato de ecuaciones
%--------------------------------------------------------------------------

\usepackage{textcomp}
\usepackage{mathtools}
\usepackage{commath}

% Teoremas
%--------------------------------------------------------------------------

\newtheorem{thm}{Teorema}
\newtheorem*{thm*}{Teorema}
\newtheorem{cor}[thm]{Corolario}
\newtheorem{lem}[thm]{Lema}
\newtheorem{prop}[thm]{Proposición}
\theoremstyle{definition}
\newtheorem{defn}[thm]{Definición}
\newtheorem*{defn*}{Definición}
\theoremstyle{remark}
\newtheorem{rem}[thm]{Observación}



% Atajos.
% Se pueden definir comandos nuevos para acortar cosas que se usan
% frecuentemente. Como ejemplo, aquí se definen las letras dobles usadas para
% los conjuntos de los números naturales, enteros, racionales, reales
% y complejos.
%--------------------------------------------------------------------------

\def\NN{\mathbb{N}}
\def\ZZ{\mathbb{Z}}
\def\QQ{\mathbb{Q}}
\def\RR{\mathbb{R}}
\def\CC{\mathbb{C}}

% Paquetes para la inserción de imágenes y figuras
%--------------------------------------------------------------------------

\usepackage{float}
\usepackage{graphicx}
\usepackage{epstopdf}
\usepackage{caption}

% Formato de los índices
%--------------------------------------------------------------------------
\usepackage{hyperref} % referencias interactivas
\hypersetup{
    colorlinks=true,
    linkcolor=blue,
    filecolor=magenta,      
    urlcolor=cyan,
    citecolor=blue,
    pdftitle={\titre},
    bookmarks=true
}
\usepackage{tocloft} % paquete de diseño tipográfico

\renewcommand{\cftsecfont}{\normalfont} % evita que los títulos del índice aparezcan en negrita
\renewcommand{\cftsecleader}{\cftdotfill{\cftdotsep}} % crea una línea de puntos entre el índice y el número

% Paquetes y configuración para la inserción de código
% Por defecto los colores emulan los del editor de MATLAB
%--------------------------------------------------------------------------

\usepackage{color}
\usepackage{listings}

\definecolor{mGreen}{rgb}{0,0.6,0}
\definecolor{mGray}{rgb}{0.5,0.5,0.5}
\definecolor{mPurple}{rgb}{0.58,0,0.82}
\definecolor{mBlue}{rgb}{0.25,0.5,0.75}
\definecolor{mRed}{rgb}{0.6,0,0}
\definecolor{mMauve}{rgb}{0.58,0,0.82}
\definecolor{backgroundColour}{rgb}{0.95,0.95,0.92}

\lstdefinestyle{CStyle}{
    backgroundcolor=\color{backgroundColour},   
    commentstyle=\color{mGreen},
    keywordstyle=\color{magenta},
	emph={TEEC_Result,TEEC_Context,TEEC_Session,TEEC_Operation,TEEC_UUID, uint32_t, TEE_Result,
	TEE_Param  },
    emphstyle=\color{magenta},
    numberstyle=\tiny\color{mGray},
    stringstyle=\color{mPurple},
    basicstyle=\footnotesize,
    breakatwhitespace=false,         
    breaklines=true,                 
    captionpos=b,                    
    keepspaces=true,                 
    numbers=left,                    
    numbersep=5pt,                  
    showspaces=false,                
    showstringspaces=false,
    showtabs=false,                  
    tabsize=2,
    language=C
}

\lstdefinestyle{BitBakeStyle}{
    backgroundcolor=\color{backgroundColour},   
    commentstyle=\color{mGreen},
    keywordstyle=\color{mBlue},
    emph={SUMMARY, DESCRIPTION, HOMEPAGE, SECTION, LICENSE, LIC_FILES_CHKSUM, SRC_URI, S, do_configure, do_compile, do_install, FILES_\${PN}, inherit, DEPENDS, RDEPENDS_\${PN}, BBCLASSEXTEND, COMPATIBLE_MACHINE, PACKAGE_ARCH, EXTRA_OECONF, EXTRA_OEMAKE, EXTRA_OECMAKE, EXTRA_OECMAKE_BUILD, EXTRA_OECMAKE_INSTALL, EXTRA_OECMAKE_TEST},
    emphstyle=\color{magenta},
    numberstyle=\tiny\color{mGray},
    stringstyle=\color{mPurple},
    basicstyle=\footnotesize\ttfamily,
    breakatwhitespace=false,         
    breaklines=true,                 
    captionpos=b,                    
    keepspaces=true,                 
    numbers=left,                    
    numbersep=5pt,                  
    showspaces=false,                
    showstringspaces=false,
    showtabs=false,                  
    tabsize=4,
    language=sh
}

\definecolor{terminalbgcolor}{HTML}{330033}
\definecolor{terminalrulecolor}{HTML}{000099}
\lstdefinestyle{ConsoleStyle}{
	backgroundcolor=\color{terminalbgcolor},
	basicstyle=\color{white}\fontfamily{fvm}\footnotesize\selectfont,
	breakatwhitespace=false,  
	breaklines=true,
	captionpos=b,
	commentstyle=\color{mGreen},
	deletekeywords={...},
	escapeinside={\%*}{*)},
	extendedchars=true,
	frame=single,
	keepspaces=true,
	keywordstyle=\color{blue},
	%language=none,
	morekeywords={*,...},
	numbers=none,
	numbersep=5pt,
  framerule=2pt,
	numberstyle=\color{mGray}\tiny\selectfont,
	rulecolor=\color{terminalrulecolor},
	showspaces=false,
	showstringspaces=false,
	showtabs=false,
	stepnumber=2,
	stringstyle=\color{mMauve},
	tabsize=2
}

% Define glossary entries
%--------------------------------------------------------------------------
\usepackage[acronym]{glossaries}
\makenoidxglossaries
\input{glossary.tex}


% Encabezado y pie de página (no es necesaria modificación)
%--------------------------------------------------------------------------

\usepackage{fancyhdr} % Paquete de estilo 
\setlength{\headheight}{12.2pt}
\pagestyle{fancy} % selección del estilo
\fancyhf{}

\renewcommand{\headrulewidth}{0.5pt} % Grosor de las líneas
\renewcommand{\footrulewidth}{0.5pt}

\lhead{\scshape OP-TEE - Internship report} 
%\rhead{\titre}
\lfoot{\auteur}
\rfoot{\thepage}

% Inicio del documento
%--------------------------------------------------------------------------

\begin{document}
% Si no se desea portada, sustitúyanse las siguientes líneas por:
%\title{\titulo}
%\author{\autor}
%\date{\fecha}

% Portada
%----------------------------------------------------------------------

\begin{titlepage}

    \centering

    \includegraphics[width=0.4\textwidth]{images/Logo_t&s.png}\hfill
    \includegraphics[width=0.5\textwidth]{images/Logo_UB.png}\par\vspace{0.5cm}



    \vspace{2cm}

    {\scshape\Large \matiere\par}

    \vspace{1.5cm}

    {\huge\bfseries \titre\par}
    \vspace{0.1cm} \cursus

    \vspace{3cm}

    {\Large\itshape \auteur} \par\vspace{0.1cm} \tuteur %\par\vspace{0.1cm} \autor3}

    \vfill

    \ville\par

    \today
\end{titlepage}

% Dejamos la siguiente página en blanco y sin numerar:

%\clearpage\thispagestyle{empty}\mbox{}\setcounter{page}{0}\clearpage

% Abstract (borrar el "%" si se requiere)
%----------------------------------------------------------------------
%\abstract{}

% Sommaire
%----------------------------------------------------------------------
\tableofcontents
\listoffigures
\listoftables

\newpage{} % Enlever si pas de saut de page après le sommaire

\section*{Introduction}
\subsection*{Context \& Problematic}
The embedded world is expanding rapidly, because it's synonymous with a connected, intelligent world.
Since the first \Gls{embedded system}, the Apollo guidance Computer developed in the 60s, embedded systems have become ubiquitous in our daily lives. We find them in telephones, cars, connected watches, bank cards, robot control systems, drone control systems and many others, making them just as important as a conventional computer. In fact, an embedded system can be seen as a conventional computer, but with limited resources and a very specific task to perform (e.g. controlling a drone), in a bigger system (e.g. the drone itself), although it may have superior computing power.




\textbf{So what distinguishes an embedded system from a conventional computer?}\\
First of all, an embedded system often includes a \gls{SOC}, i.e. all the components of a computer are integrated on a single chip, and may also include other components such as microcontrollers, sensors and interfaces, depending on the specific application. But the most important difference in the context of this internship is the processors used. In the vast majority of cases these are \gls{ARM}, RISC (Reduced Instruction Set Computer) processors, as they consume less energy and are more compact than \gls{X86} processors based on CISC (Complex Instruction Set Computer) architecture.

% TODO: Parler de Linux embarqué

From a security point of view, embedded systems have become prime targets for hackers. These systems are often used to process sensitive data, and are often connected to the Internet. It is therefore essential to secure these systems to prevent data theft or unauthorized remote control.

This raises the following question: \textbf{How to secure an embedded system?} \\
There are several solutions for this. We can talk about the whole network and communication security aspect, but also, at a lower level, about securing the hardware itself. It's on this last point that this internship has focused. Throughout this internship report, we'll be looking at how it's possible to secure an embedded system using a \gls{TEE}, which is fortunately one of the technologies offered by some ARM processors (\gls{ARM TrustZone}), as well as real-life applications of this technology in different contexts.


\newpage
\section{Objectives}
Several objectives have been set for this internship:
\begin{itemize}
    \item The first is to understand how a \gls{TEE} works, more specifically \gls{OP-TEE} which is an open-source implementation of TEE for \gls{ARM} processors, and all the technologies that revolve around it. A detailed state-of-the-art report is expected.
    \item Next, training on the build tool \gls{Yocto Project}. The aim here is to understand how to create a customized \gls{Linux based image} for an embedded system and integrate OP-TEE into it.
    \item Finally, to put into practice what I've learned by working on this internal R\&D project. The aim of this project was to develop a secure logging application for an embedded system, specifically a \gls{PICO-PI-IMX8M}. This application would allow logs to be stored securely in an environment isolated from the rest of the system.
    \item \textbf{Bonus :} Being assigned to an industrial project for a real customer with real constraints as support for my tutor Mohamed Belouarga, who is also on the project. The aim is to provide support as an embedded Linux and OP-TEE expert for a project to secure a specific embedded platform.
\end{itemize}



\section{Presentation of the company and work environment}
First and foremost, a presentation of the company and its working environment is necessary to fully understand the challenges of the internship.

\subsection{Company presentation}
This internship will take place at \gls{TnS}. Founded in 2008 by Jeremy HUSS in Strasbourg, now the head office, the Technology and Strategy group is a European consultancy group specialising in the digital sector, with a turnover of over 350 million euros in 2023. In sixteen years, the group has grown from 7 to more than 4,000 employees spread across 31 agencies in 13 different countries. T\&S operates mainly in Europe, but also has branches in Egypt, Singapore and Hong Kong.
\begin{figure}[H]
    \centering
    \includegraphics[width=0.5\textwidth]{images/TnS_Locations.png}
    \caption{Location of the various offices (Image Credit: Technology and Strategy)}
    \label{fig:Locations}
\end{figure}

The T\&S Group is represented throughout the world by various innovative internal entities with different consultancy specialities. This breakdown enables the T\&S Group to provide its clients with the best possible support according to their needs.

\begin{figure}[H]
    \centering
    \includegraphics[width=0.8\textwidth]{images/TNS_decompo.png}
    \caption{Main entities in the T\&S group (Image Credit : Technology and Strategy)}
    \label{fig:TnS_entities}
\end{figure}

Through its entities, T\&S is divided into three sectors of activity:
\begin{itemize}
    \item Engineering, which accounts for 48\% of T\&S's business sector, with 4 specialities: embedded systems, product development, project management and process optimisation. This sector is managed by Technology and Strategy Engineering, Englab, Topic and Seintech.
    \item Digital, which accounts for 29\% of the sector. It is based around 4 main areas: business intelligence, \gls{IT} management, application development and industrial IT. Entities such as Degetel and Novencia occupy this sector.
    \item Consulting, which is the main interface with customers. The managers manage the teams of consultants, the progress of projects, the achievement of objectives, the search for assignments and recruitment. T\&S, Antaes and Intys are the group's main players in this area of expertise.
\end{itemize}

\begin{figure}[H]
    \centering
    \includegraphics[width=0.8\textwidth]{images/TNS_activites.png}
    \caption{Sectors of activity (Image Credit : Technology and Strategy)}
    \label{fig:sector_activity}
\end{figure}

\subsection*{Work environment}
So I joined T\&S as a trainee in what they call the \gls{Embedded Linux} \gls{practice} which is one of the group's specialities. This practice is made up of several consultants spread across the south-west of France, including my tutor Mohamed Belouarga, and Practice Leader Fabien LAHOUDERE, whose job it is to advise customers on the technological choices to be made for their embedded projects. They are also responsible for carrying out these projects.

\begin{figure}[H]
    \centering
    \includegraphics[width=1\textwidth]{images/TNS_PLINUX.png}
    \caption{Presentation of the embedded Linux practice (Image Credit : Technology and Strategy)}
    \label{fig:Pres_practice}
\end{figure}

The primary subject of this internship was an internal assignment for the embedded Linux practice. This meant that the project was not for a customer but for the company itself. In fact, all interns and apprentices are assigned an internal R\&D project. This setup allowed for learning about new technologies without specific pressure. It also facilitated familiarization with the company’s work tools and understanding of project management processes. These internal projects, also known as inter-contract projects, are carried out by consultants who do not have a current mission.

A Windows-based laptop was provided for the work, where a virtual machine running on Linux were installed. This virtual machine was essential for the work, as all the tools needed for embedded development could be installed on it. There was also access to a \gls{build server} and a \gls{PICO-PI-IMX8M} embedded system for testing applications in real conditions. Much later in the internship, I was lucky enough to start working on an industrial project for a real customer. For this project, remote access was provided to a SoM specifically designed for the project and to a new laptop running exclusively on Linux, eliminating the constraints typically associated with a virtual machine.

\subsection{Environmental and social impacts}
The subject of this internship is not directly linked to the ecological transition. However, it is important to note that embedded systems are increasingly used in fields that can have an impact on the environment. For example, on-board systems are used in solar panels to control energy production, in wind turbines to control energy production, in air quality control systems, and so on. It is therefore important to secure these systems to prevent any unauthorised control, which could have disastrous consequences for the environment.

Concerning the company's environmental policy. T\&S has made sustainable development a pillar of its strategy, transforming environmental objectives into economic growth drivers. To achieve this, the group is committed to continually improving its environmental performance by setting ambitious objectives and targets. In terms of social responsibility, T\&S is a signatory of the Diversity Charter in France and works with the ‘Elles bougent’ association to encourage more women to enter the engineering and digital professions, as well as with the d-clic association, which offers Ninth Grader internships to young people from disadvantaged neighbourhoods to help them succeed at school and inspire new vocations.

%----------------------------------------------------------------------
\section{Internal R\&D project}

\subsection{State of the art}
\label{sec:SOA}
As the subject of this internship is highly technical, it is necessary to carry out a state-of-the-art study to understand the technologies used. This state of the art was carried out at the beginning of the internship, and enabled us to understand the challenges of embedded system security, the technologies used to secure them, and more specifically the \gls{TEE}, \gls{ARM TrustZone} and \gls{OP-TEE}.

You can find this state of the art in annex \href{run:./State-of-the-Art\_OPTEE-OS.pdf}{State-of-the-Art\_OPTEE-OS}.

Here, however, is a summary of the key points:
\subsubsection{Trusted Execution Environment Concepts}
\begin{figure}[H]
    \centering
    \includegraphics[width=0.8\textwidth]{images/TEE_Building_blocks.png}
    \caption{TEE Building Blocks (Image Credit : \cite{7345265})}
    \label{fig:blocks}
\end{figure}
A \textbf{TEE} is a tamper-proof processing environment that runs on a \textbf{Separation Kernel} (a security kernel that allows different systems requiring different levels of security to coexist). It guarantees the authenticity of executed code, the integrity of execution states (e.g. sensitive CPU registers, memories and I/O), and the confidentiality of its code, data and execution states stored in persistent memory. In addition, it must be able to provide remote certification that proves its reliability to third parties. The content of a TEE is not static; it can be securely updated.

\subsubsection{ARM TrustZone}
\begin{figure}[H]
    \centering
    \includegraphics[width=0.8\textwidth]{images/NS_and_S_world.png}
    \caption{Secure and non-secure world (Image Credit : ARM \cite{TrusteZoneAArch64})}
    \label{fig:NS_S}
\end{figure}
\textbf{TrustZone} is a technology used by \textbf{ARM processors} to isolate security-critical components in a system, by hardware separating a so-called \textbf{non-secure} operating system (or \textbf{Rich OS}) from a much smaller, \textbf{secure} operating system (or \textbf{Trusted OS}). More specifically, it is designed to provide a hardware-reinforced logical separation between the security components and the rest of the \gls{SOC} infrastructure. This makes it possible to combat both hack attacks (where the hacker is only capable of executing a software attack) and shack attacks (a low-budget hardware attack, using equipment that could be bought on the high street from a store such as Radio Shack).

\subsubsection{OP-TEE}
\begin{figure}[H]
    \centering
    \includegraphics[width=1\textwidth]{images/OP_TEE_Soft_Archi.png}
    \caption{OP-TEE software Architecture (Image Credit: \cite{Demyst})}
    \label{fig:OPTEE-ARCHI}
\end{figure}
\textbf{OP-TEE} is an open-source implementation of a \textbf{TEE} for \textbf{ARM processors}. It is based on the \textbf{ARM TrustZone} technology and is designed to provide a secure execution environment for sensitive code and data. OP-TEE is a project of the Linaro group, which is a collaborative engineering organization that works on open-source software for the ARM architecture. OP-TEE is designed to be portable and can be used on a wide range of ARM processors. It is also designed to be easy to use and integrate into existing systems.


\subsection{Project planning and management}
To make the most of this internship, it was necessary to carefully plan the work to be done. The project was organized using a \gls{Gantt} (used to visualize project tasks over time, showing their duration and sequence). Although this was an individual project with no real client and no strict deadline, using the Gantt helped to structure the various stages of the work in a clear, chronological way. This planning helped to recreate working conditions close to reality, giving an insight into the project management methods commonly used in a professional environment. It also made it easier to monitor progress while improving the organization and prioritization of tasks, all within the set time limits.

All code versioning was done on GitLab. Thanks to GitLab's ticketing system, each of the project's previously defined objectives has been broken down into sub-tasks. Here, each sub-task represents the “TO-DOs” or actual work to be done. Since only one repo has been set up for this project and I'm the only contributor, I've decided to allocate a repo branch for each expected deliverable such as the internship documents (the latex code of the State-of-art and the report), the data relating to \gls{Yocto Project} and \gls{Linux based image} customized for the project as well as the source code of the application created. This made it possible to work in isolation on each task, and to go back if necessary. Being the only contributor to the project and taking into account the constraint of having only one repo, I allowed myself this approach, but in a professional context, it's preferable to work on separate branches for each feature and merge them into the main branch once the work is done. Nevertheless, here you can be sure of not losing anything in the event of a problem, and of being able to retrieve all internship data at any time.

As an intern, it was essential for T\&S to follow the progress of the project. To this end, a daily meeting was organized, bringing together all the interns, the inter-contract consultants, and at least one company tutor (depending on their availability). These meetings were an opportunity to review the tasks carried out the previous day, any difficulties encountered, the tasks to be carried out during the day and any problems encountered. This kept track of the project's progress, ensured that everyone was on the same wavelength, and enabled any problems to be resolved quickly. These meetings were also an opportunity to ask questions on technical subjects, or to ask for help if necessary.

\subsection{Effective work}

Let's recall the second objective of this internship: to learn how to use Yocto to understand how to create a customized Linux image for embedded systems and integrate OP-TEE into it.

\subsubsection{Yocto}
Learning the basics of Yocto was therefore a prerequisite for this project. So I started by documenting myself on the subject, by reading the official Yocto documentation, watching tutorials on Youtube, and reading blog posts.

Here is a list of the most useful resources found :
\begin{itemize}
    \item \href{https://www.youtube.com/watch?v=8M8U1EgnUVw}{ Getting started with Yocto Project - Chris Simmons - NDC TechTown 2022 } : This video helped me understand the basics of Yocto, its history, its purpose, how it works and how it's structured, with a bonus demo of how to create a custom Linux image.
    \item \href{https://docs.yoctoproject.org/index.html} {Yocto Project Documentation} : The official Yocto documentation, which is very complete and well structured.
    \item \href{https://www.blaess.fr/christophe/yocto-lab/} {Linux embarqué avec Yocto Project - Christophe BLAESS} : An online course on Yocto for beginners to learn while you practice.
\end{itemize}

To summarize the content of these resources and explain the basic concepts so as to gain a better vision of Yocto Project for the rest of this report, here's what we can retain:

The Yocto Project is an open-source initiative led since 2010 by the Linux Foundation and 22 partner organizations to provide tools, metadata and processes for embedded systems development. It enables the creation of \glspl{Linux distribution} customized to a specific project, bringing great flexibility to the developers who use it, but also by extension to build any software as long as the build process is well defined into Yocto Project. Among other things, this makes it possible to obtain lightweight Linux distrubutions, optimized for specific hardware, and to guarantee system security by integrating technologies such as OP-TEE much more easily than with traditional methods.

\begin{figure}[H]
    \centering
    \includegraphics[width=1\textwidth]{images/yp-how-it-works-new-diagram.png}
    \caption{Yocto project - How it works (Image Credit: \cite{Yocto_project})}
    \label{fig:YCTO-HOW-WORK}
\end{figure}

Figure \ref{fig:YCTO-HOW-WORK} shows how the various elements interact to create a customized Linux image. You can see that Yocto is a very powerful tool. However, it's also very complex.

Yocto Project has several strings to its bow, such as \gls{BitBake}, which defines the entire build system, so it will take care of source retrieval (local or not), version management, version configuration, dependency management, compilation, image creation and license management, to name but a few. The decision to use a tool as complex as Yocto is justified in partly by the fact that embedded systems are often highly specific and therefore need to adapt the software layer to these constraints. Yocto focuses on tracking these specificities, as any specification/overlayer added to the software is recorded in a recipe and patches, and any modification to an existing recipe is recorded in recipe extension files. This makes it easy to track changes made to the software and reproduce them. Yocto also sets up a number of project-wide environment variables to facilitate configuration of a \gls{cross-compilation} project.

From a developer's point of view, Yocto defines a number of key concepts, such as :
\begin{itemize}
    \item \textbf{\Glspl*{recipe} (.bb ou Meta)} : These are files that describe how to build a software package with which particular configuration or patches and where to install it on the final image. They contain information on dependencies, sources, patches, environment variables and so on. BitBake then manages the various tasks defined in a recipe.
    \item \textbf{\Glspl*{layer}} : These are directories containing recipes and configurations. They can be used to separate recipes and configurations according to their usefulness and the group to which they belong. There are official layers and community layers.
\end{itemize}

To better understand these concepts. Let's take the example of a shortened recipe for a simple C program “Hello world”:
\begin{lstlisting}[style=BitBakeStyle, title=hello\_world\_exemple.bb]
# File: meta-recipes-example/hello-world-project/hello-world-project.bb

SUMMARY = "A simple hello world application"
DESCRIPTION = "A simple hello world application built with a Makefile."

LICENSE = " .. "
LIC_FILES_CHKSUM = " .. "
SRC_URI = " ... "
SRC_URI[md5sum] = " ... "

S = "${WORKDIR}/hello-world-project"

depend some-dependency ...

do_configure() {
    # Configuration needed for the project
}

do_compile() {
    # How to compile the project
    oe_runmake -C src
}

do_install() {
    # Where to install the build output
    install -d ${D}${bindir}
    install -m 0755 src/hello-world ${D}${bindir}/hello-world
}

# ...
\end{lstlisting}

In this example, we can see that the recipe contains information on the program, its license, its sources, its dependencies, how to compile it, how to install it, and so on. This recipe can use global environment variables (such as \texttt{D}: the compilation destination directory, for example), but also variables local to the recipe.
We can also see that the recipe is in a \texttt{meta-recipes-example/} directory, which is a layer.


\subsubsection*{Problem with image construction}
Building an image requires enormous resources and takes a lot of time. I learned this the hard way when I tried to build the simple basic image provided by the Yocto layer for training purposes. This posed a real problem at first, as the appropriate methods for optimising the incremental construction proposed by BitBake had not yet been mastered. Each modification, however small, led to a complete reconstruction of the image, including all the recipes, which took between 2 and 3 hours to finalise.

BitBake offers an incremental build, meaning that it only rebuilds elements that have changed since the last build. To do this, a radical and safe method has been to directly delete the output directory of a recipe because they contain buffer files that will tell BitBake whether or not the recipe compilation task has been completed. More precisely, Bitbake will save a \gls{checksum} calculated according to the various parameters (sources, dependencies, environment variables, etc) and will compare it with that calculated during the current compilation. This saves time when building an image. However, for this to work, the dependencies must be well defined in the recipes.
\\Another solution to save even more time was to have access to the embedded Linux Practice \gls{build server}. This server is made up of an Intel Xeon E-2136M with 6 cores and 12 threads, 32 GB of RAM which is 4 cores more than my laptop and 16 GB more RAM. This enabled me to halve the time taken to build the image, which is not insignificant.
The last solution was to choose to build a minimalist image, i.e. an image containing only the bare minimum needed to boot a Linux system. This allowed me to save even more time when building the image of around 15-20\%.

\begin{notes}
    \item Throughout this project, the Krikstone version of Yocto Project was used. This version, considered to be the most stable with long-term support, was recommended by my tutor. All the Yocto Project overlays used are therefore based on this version.
\end{notes}


\subsubsection{System on Module PICO-IMX8MQ(R40)}

\begin{figure}[H]
    \centering
    \includegraphics[width=0.6\textwidth]{images/PICO-PI.png}
    \caption{PICO-PI-IMX8M (Image Credit: TechNexion)}
    \label{fig:NXP-IMX8M}
\end{figure}
Now that we've seen the basics of Yocto Project, and managed to compile an image, we can turn our attention to the embedded target on which the project was focused, as this is the one on which we carried out the actual tests. It's a TechNexion \gls{PICO-PI-IMX8M} based on a NXP I.MX 8M Quad \gls{SOC}. This system is actually an \gls{Evaluation Kit} consisting of a \gls{carrier board} housing a \gls{SOM} PICO-IMX8MQ(R40). This choice is due to the fact that the Embedded Linux Practice wanted to diversify its development and test platforms towards an I.MX 8 SoC, which is widespread among its customers, as until now it has worked mainly with Raspberry Pi, NVIDIA Jetson and STM32.

The I.MX 8M Quad SoC is a quad-core ARM Cortex-A53 processor running at 1.3 GHz, with an ARM Cortex-M4 co-processor. It is also equipped with a GPU and a VPU. It is designed for multimedia and machine vision applications. It is therefore perfect for embedded applications requiring significant computing power. It is also equipped with ARM TrustZone technology, making it perfect for integrating a TEE. See figure \ref{fig:NXP-IMX8M}.

\begin{figure}[H]
    \centering
    \includegraphics[width=0.9\textwidth]{images/NXP_IMX8.png}
    \caption{SoC NXP I.MX 8M blocks diagram (Image Credit: NXP)}
    \label{fig:NXP-IMX8M}
\end{figure}

The PICO-IMX8MQ SoM will provide the necessary interfaces for the SoC, as well as 4GB of RAM and 16GB of eMMC storage. See figure \ref{fig:PICO-IMX8MQ}.

\begin{figure}[H]
    \centering
    \includegraphics[width=1\textwidth]{images/PICO-IMX8.png}
    \caption{SoM PICO-IMX8M blocks diagram (Image Credit: TechNexion)}
    \label{fig:PICO-IMX8MQ}
\end{figure}


\subsubsection{Board support package}
To be able to use the board, you need a \gls{BSP} which will enable you to configure it and provide the drivers, firmware and other software needed to make it work. TechNexion provides a BSP for the PICO-IMX8MQ on Yocto Project. This BSP is composed of several Yocto layers, including NXP's lower-level layer serving as the BSP for the SoC, TechNexion's layers, and many other layers forming a complete package for the PICO-IMX8MQ. This Yocto BSP comes with recipes for configuring and building a basic image for the PICO-IMX8MQ, as well as recipes for building more complete images with graphical interfaces, multimedia applications, etc. This Yocto BSP is available in this Github repo : \href{https://github.com/TechNexion/tn-imx-yocto-manifest/tree/kirkstone_5.15.y-stable}{tn-imx-yocto-manifest}

Installation is relatively straightforward, we just need to clone the repo and install the necessary dependencies as well as the \texttt{repo} tool. This tool allows you to clone several Git repositories at the same time and synchronise them. These Git repositories are defined in a manifest in the form of an XML file. Once all the repos have been cloned correctly, everything is ready for the Yocto Project distribution, Poky, which will contain all the tools that make up Yocto Project.


All that remains is to configure the build environment and use the command to start building the image:
\begin{lstlisting}[style=ConsoleStyle, title=Build environment configuration]
    WIFI_FIRMWARE=y DISTRO=fsl-imx-xwayland MACHINE=pico-imx8mq source tn-setup-release.sh -b build-xwayland-pico-imx8mq
\end{lstlisting}

This line is used to configure the build environment using the \texttt{build-xwayland-pico-imx8mq} directory. The \texttt{WIFI\_FIRMWARE=y} parameter is used to build an image with the firmwares for wifi, the \texttt{DISTRO=fsl-imx-xwayland} parameter is used to choose the Yocto Project distribution to use, and the \texttt{MACHINE=pico-imx8mq} parameter is used to choose the target machine. Finally, the \texttt{source tn-setup-} \texttt{release.sh} command is used to configure the build environment.

From now on, configuration files such as \texttt{local.conf} and \texttt{bblayers.conf} will be generated and we'll be able to modify them to add layers, or modify environment variables etc...

\begin{notes}
    \item For each instance of the console, the build environment must be reconfigured using the \texttt{source setup-environment build-xwayland-pico-imx8mq} command to ensure that the environment variables are properly configured and that tools such as BitBake are accessible.
\end{notes}

We now have access to all the tools and can start building the image:
\begin{lstlisting}[style=ConsoleStyle, title=Launch of the image construction]
    bitbake imx-image-core
\end{lstlisting}

\begin{figure}[H]
    \centering
    \includegraphics[width=1\textwidth]{images/Bitbake_build.png}
    \caption{Bitbake build process console output}
    \label{fig:BB-console-output}
\end{figure}

\subsubsection{Flashing the board}
\begin{notes}
    \item Flashing a board refers to the process of writing firmware or an operating system image onto the non-volatile memory of an embedded system or development board.
\end{notes}
To flash the card, TechNexion and NXP recommend using the \texttt{UUU} tool, developed specifically to deploy images on NXP SoMs. Once the necessary software has been installed, a simple command is used to flash the images. First of all, jumpers need to be set to put the card into ‘flash mode’, which puts the card into serial download mode. In this mode, the SoC waits for instructions from a host computer via USB, allowing the UUU tool to communicate with the card and write the new firmware or image. We also had to find the right connections on the PC to ensure that the SoM was correctly recognised and powered by the PC (one USB for power and another for communication), because the laptop's USB outputs don't always supply enough current to power the card correctly, causing errors on start-up. It was also necessary to configure the virtual machine's USB parameters to ensure correct recognition of the SoM.
\\Simply run the \texttt{minicom} program to view the console output and check that it is working correctly. During the flash operation, the card communicates the progress of the operation to \texttt{minicom}, and once the process is complete, simply restart the card for the image to be loaded. At this point, \texttt{minicom} will act as the main console for the card. The base image supplied by TechNexion was found to work correctly and the card was found to be fully operational.

\subsubsection{OP-TEE integration}

After checking that the card was working correctly, the integration of OP-TEE into the image could begin. Following a search, it was found that the NXP BSP provides recipes for embedding OP-TEE (version 3.19.0) into an image for the I.MX6, I.MX8 and I.MX9 SoCs, including specifically for the I.MX8MQ. These recipes are available in the \texttt{meta-imx} layer and include one recipe, \texttt{optee-os\_3.19.0.bb}, for building OP-TEE OS (the software running in the TEE), another for building \texttt{optee-client\_3. 19.0.bb}, the Linux tools used to communicate with the TEE, as well as \texttt{optee-test\_3.19.0.bb} for the OP-TEE unit tests (see figure \ref{fig:OPTEE-ARCHI}). BitBake must then be told to build these recipes by adding them to the environment variable \texttt{IMAGE\_INSTALL}.

Once the image has been correctly constructed, the card can start up correctly.

% Problème de demarage impossible, bloqué au \gls{SPL U-Boot}. Après plusieurs jours de recherche, il s'est avéré que les configuration de OP-TEE n'était pas les bonne pour la board du projet. En effet, malgré que la configuration utilisé soit bien celle de \texttt{pico-imx8mq}, il existe différents type de \texttt{pico-imx8mq}. Le BSP de NXP n'as pris en compte qu'une seule version de la board, celle avec 3Go de RAM et non 4Go.
% \begin{figure}[H]
% 	\centering
% 	\includegraphics[width=0.8\textwidth]{images/PICO-IMX8MQ-R40.png}
% 	\caption{PICO-PI-IMX8MQ different versions (Image Credit: TechNexion)}
% 	\label{fig:IMX8-DIFFERENT-VER}
% \end{figure}

% Ce qui explique pourquoi la board ne demarrais pas apres le SPL, car le SPL ne pouvait pas correctement charger OP-TEE OS dans la RAM, sont adresse de chargement étant calculé pour etre à la toute fin de la RAM, elle était donc après l'adresse de fin de RAM spécifié par la configuration utilisé dans OP-TEE OS, les bootloader et meme le \gls{Device Tree Blob}. Pour corriger le problème il a fallu modifier certaine variable de la recette d'OP-TEE OS pour qu'elle corresponde à la configuration de la board. Il a également fallu modifier le DTB ainsi que le code du SPL pour qu'il charge OP-TEE OS correctement. Pour modifier une recettes, tout peux ce faire dans un fichier \texttt{.bbappend} qui viendra automatiquement surcharger une recette deja existante du meme nom, il suffit alors de redéfinir les variables que l'on souhaite modifier. Pour modifier les fichier sources il faut obligatoirement soit fournir les sources directement modifier ou créer un patch que BitBake appliquera après avoir cloner les sources ce patch sera ensuite également défini dans un fichier \texttt{.bbappend}. Maintenant la question était de savoir ou placer ces fichiers et comment les inclure dans l'image. Comme dis précedement, Yocto Projet fonctionne avec des layers qui sont des répertoires contenant des recettes et des configurations. Il suffit alors de créer un layer contenant les fichiers de configuration et les patchs et de l'ajouter à la liste des layers disponible pour la construction de l'image. Ensuite, l'arboresence des fichiers doit être respecté pour que BitBake puisse trouver automatiquement les \texttt{.bbappend} et les patchs.

% Le problème en utilisant Yocto est qu'il est compliqué de dérouler le fils pour savoir quel configuration et quel fichiers rentre vraiment en jeux et à quel point ils sont liées entre eux. Par exemple, il n'est pas spécifier explicitement que les recetes d'OP-TEE utilisé serait celle du layer \texttt{meta-imx}, par contre, il est spécifié dans un fichier inclu dans un des fichiers inclu dans la recette de l'image que la version préféré de OP-TEE est la 3.19.0. Yocto va alors chercher parmis toutes les recettes recensé la recette qui correspond à cette version et il se trouvais que c'était celle du layer \texttt{meta-imx}. Les recettes spécifient aussi des variable de configuration utilisé dans les makefiles, il faut donc accéder à ces sources et voir comment ces variables sont utilisé pour comprendre comment les modifier lorsque la documentation n'est pas suffisante. Je suppose qu'il y a très certainement des solutions, des bonnes pratique plus efficace que de chercher dans tout les fichiers de configuration, toutes les recettes pour trouver la source du problème, mais je n'ai pas eu l'occasion de les apprendre.

% En tout cas désormais, l'image contient bien OP-TEE et la board démarre correctement à partir de cette instant. Il ne reste plus qu'à tester les fonctionnalités de OP-TEE et à les intégrer dans une application. 

\subsubsection{OP-TEE test : xtest}
OP-TEE is supplied with a set of unit tests to test the functionality of OP-TEE. These tests are provided in a separate OP-TEE OS recipe that has been integrated into the image. The tests will then communicate with OP-TEE OS to test the various features of OP-TEE. These tests are very useful for checking that OP-TEE is working correctly and that the OP-TEE functions are properly integrated into the image. To run the tests, simply issue the following command:
\begin{lstlisting}[style=ConsoleStyle, title=Launch of OP-TEE unit tests]
    xtest
\end{lstlisting}

During the execution of the tests, an error occurred right at the start, causing the tests to come to a complete halt. More precisely, it was a simple segfault, which was already a good clue as it indicated a problem with memory management. To obtain more details on this error, the OP-TEE OS logs and those of the Linux clients were activated to the maximum, which was done via the Makefiles variables in the Yocto recipes. After re-running the tests, no error message was displayed. Instead, an OP-TEE OS error message appeared, indicating that an address used was a bad argument, as well as the function causing the error. However, the address specified in the error message was a valid physical address according to the card's reference manual. Why this segfault?\\
After several days of research, it turned out that the segfault was not directly linked to the OP-TEE OS error but was rather caused by a call to close a session that had not been opened because the \gls{Trusted Application} encountered an error and stopped the session opening process. In addition, it was discovered that the configurations of OP-TEE and other image components were not suitable for the project board. Although the configuration used was \texttt{pico-imx8mq}, there are different types of \texttt{pico-imx8mq}. The NXP BSP only took into account one version of the SoM, the one with 3 GB of RAM, and not the one with 4 GB.

\begin{figure}[H]
    \centering
    \includegraphics[width=0.8\textwidth]{images/PICO-IMX8MQ-R40.png}
    \caption{PICO-PI-IMX8MQ different versions (Image Credit: TechNexion)}
    \label{fig:IMX8-DIFFERENT-VER}
\end{figure}

This explains something about the OP-TEE OS error because the address returned in the error was indeed an address pointing to the 4th Gigabyte of memory. My understanding of the problem is that the vision of memory between Linux and OP-TEE OS was not the same. This posed a problem for shared memory. Linux was sharing data via shared memory with OP-TEE OS in a place that OP-TEE OS said was off-limits.\\
We therefore had to modify a number of variables in the OP-TEE OS recipe to match the board's 4GB configuration. We also had to modify the \gls{Device Tree Blob} which tells Linux how to use the available memory. As well as the \gls{SPL U-Boot} code so that it finds OP-TEE OS correctly when handing over, because until now it was content to do a simple calculation to find OP-TEE OS, which was always loaded at the very end of the memory. Except that now that the vision of memory has changed, OP-TEE OS is no longer at the end of the memory but at the end of the first 3 Gigabytes.

To modify a recipe, everything can be done in a \texttt{.bbappend} file which will automatically override an existing recipe with the same name. All you have to do is redefine the variables you want to modify. To modify the source files, you must either supply the modified sources directly, or create a patch that BitBake will apply after cloning the sources. This patch will then also be defined in a \texttt{.bbappend} file. The next question was where to place these files and how to include them in the image. As mentioned earlier, Yocto Project works with layers, which are directories containing recipes and configurations. So all you have to do is create a layer containing the \texttt{.bbappend} files and patches, then add it to the list of layers available for building the image. Finally, the file tree must be respected so that BitBake can find and apply the overlays automatically.

One of the challenges with Yocto is the complexity of tracing configurations and determining which files are actually involved and how they are interconnected. For example, it is not explicitly stated that the OP-TEE recipes used come from the \texttt{meta-imx} layer. However, a file included in another file, itself included in the image recipe, specifies that the preferred version of OP-TEE is 3.19.0. Yocto then searches through all the available recipes to find the one corresponding to this version, which happened to be that of the layer \texttt{meta-imx}. Recipes also define configuration variables used in Makefiles. It is therefore necessary to access the sources to understand how these variables are used and how to modify them when the documentation is insufficient. There are probably more effective solutions and best practices than having to go through all the configuration files and recipes to identify the source of a problem, but it was not possible to learn them during this project.

Once the modifications had been correctly applied and the image rebuilt and flashed, a new problem arose, this time when the card was booted, more specifically when OP-TEE OS was booted and initialised. The OS went into panic mode, causing the card to freeze completely because Linux had not yet started up. Thanks to the error message, the function responsible for the error could be identified. After a lengthy debugging process, which involved placing printouts to trace the execution of the code and gain a better understanding of the context, it was determined that the problem originated in the MMU, which was registering memory areas with an incorrect security level, causing a conflict. A patch was then created to correct this problem, allowing the OS to start up correctly. This time, all the tests were carried out without a hitch, validating the integration of OP-TEE into the image.

The next step was to concentrate on developing applications using OP-TEE. To begin with, a new recipe was installed, allowing several applications to be added as examples. As it wasn't directly available in the layers already installed for this Yocto project, an online search was carried out to find it for the version of OP-TEE used. It then simply had to be included manually in the personal layer. This recipe installs the applications in the image rootfs, enabling them to be tested directly on the map. The tests confirmed that the applications worked correctly and could be used to understand how OP-TEE works and the possible interactions with it.

\subsubsection{Secure log application}
\label{sec:SECURE-LOGS}
Once the environment had been correctly configured, the final objective was to create a secure logging application that would enable logs to be stored securely in the TEE. Knowing the behaviour of OP-TEE OS, some thought was needed to determine the architecture of this application. Initially, the idea was to develop a TA that would progressively write to a log file located in secure storage. However, it quickly became apparent that OP-TEE OS did not allow this approach. It is not the storage itself that is secure, as it is simply located in the Linux file system and therefore remains accessible by Linux (except when it points to the RPMB, which is secure), but rather the stored objects. OP-TEE OS can only store objects. These objects are secure because they are encrypted and signed by the TA that created them.
\\ We therefore opted to create a TA with two commands available for the time being: one to \textbf{store} a log and another to \textbf{get} them. When a client wishes to store a log, it must provide a unique identifier for the log as well as the log itself. When it wishes to retrieve the logs, the TA will search for all the logs recorded, concatenate them, and send them back to the client. The client will then take care of parsing them correctly. This application is therefore very simple, but gives a good understanding of how OP-TEE works and how to interact with it.

\begin{figure}[H]
    \centering
    \includegraphics[width=0.9\textwidth]{images/Secure_logs_archi.png}
    \caption{Secure logs application architecture}
    \label{fig:SECURE-LOGS-ARCHI}
\end{figure}

Two C applications have been developed for this project. The first, intended to be installed on the Linux side, currently serves as a client for testing the TA but is designed to evolve into an API accessible to any Linux application wishing to store logs in the TEE. The second application is the TA, which hosts the log storage and retrieval functions. The client uses the OP-TEE Client API supplied by OP-TEE to communicate with the TA. The TA, on the other hand, relies on a different set of APIs, running in a different Linux environment, the OP-TEE OS, and uses the OP-TEE Internal Core API functions provided by OP-TEE. For more details on the OP-TEE APIs, please refer to the state-of-the-art \ref{sec:SOA}.

The Makefiles architecture of the OP-TEE example package was used to write and compile these applications, making it possible to automate the construction of different applications provided that the sources are correctly placed in the file tree. In addition, the \texttt{optee-example} recipe installed previously was used as a reference to create a custom recipe, designed to compile and install the various applications available in the sources, which are supplied directly in a \texttt{.tar.gz}.

Developing an application on an embedded target is relatively fastidious. Especially in the context of this project. Whenever there was the slightest change, we had to recompress the sources, send them to the \texttt{build-server} in the corresponding directory, launch a Bitbake build, retrieve the compiled image from \texttt{build-server} to the local machine connected to the board, put the jumpers on the board and plug it in correctly, and finally flash the board. This took about 1 hour for each test. So, to make development and testing much easier, two scripts were created. Firstly, one to automate the compression and sending of the sources to the right place on the \texttt{build-server} and another to retrieve and launch the flashing of the board. This has saved precious time because, although the commands are the same, they are long and fastidious to type each time.

Despite everything, it has enabled me to learn to be more rigorous and to detect and prevent errors much more quickly without having to wait for an error message. From now on, every piece of code is meticulously examined in order to anticipate every possible scenario.



\subsection{Critical opinion}
This project proved to be extremely instructive, offering a deep immersion in a new development environment, namely Yocto Project, and providing an in-depth understanding of how embedded systems work. Thanks to this project, the principles of development on embedded targets were assimilated, while discovering the world of IT security, in particular the operation and use of a TEE (Trusted Execution Environment). It was also a valuable opportunity to consolidate my knowledge of Linux and the C language.
\\From a pedagogical point of view, the application of secure logs proved to be perfectly suited. In my opinion, the most complex and instructive aspect is the successful communication between two applications on different environments, Linux and OP-TEE. However, in terms of industrial relevance, the real usefulness of this application can be questioned. The process seems rather cumbersome for a task as specific as log storage, which could limit its adoption in industrial environments.
\\In conclusion, with the rise of ARM processors in embedded applications and beyond, the TrustZone technology and OP-TEE, on which this project is based, appear to have a promising future.




\section{Industrial project}

Shortly before I finished my initial internship project, I was offered an industrial mission, which I accepted as it seemed to be a very good opportunity for me. Indeed, it would enable me to continue working on embedded projects and to continue learning, but this time in a real industrial context with real constraints and challenges.

\subsection{Project background}

The aim here was to support my tutor Mohamed BELOUARGA on a project to secure an embedded target using OP-TEE and the Secure Boot concept provided by the \gls{TF-A}. We were assigned as Linux experts in a team from the T\&S Cyber-security practice based in Germany. The customer is a company specializing in IT security, and more particularly in securing embedded systems, which wanted to release a new version of their product incorporating new security concepts in order to validate new certifications. This project was handled by T\&S as an internal project with a commitment to results. This means that responsibility for the entire project was assumed by T\&S, rather than simply sending consultants to the customer to assist with the project.

For reasons of confidentiality, no names of customers or manufacturers will be given, and precise details of the project will not be divulged.

\subsection{Project planning}

The project was planned in 1, 2 or 3 week \glspl{sprint}, depending on the complexity of the tasks to be carried out, the vacations of the different team members and the deadlines to be met. Each sprint consisted of several tasks, each assigned to a team member. Tasks were defined at the start of the sprint and validated by the customer. Tasks were managed via an online project management tool, Jira, which enabled tasks to be tracked, assigned, commented on and prioritized. This enabled us to keep track of the project's progress and to know at all times what was in progress, what had been completed and what remained to be done. We also had a daily meeting every morning to review current and upcoming tasks and to discuss any problems encountered. This daily meeting was led by the Technical Manager, who was in charge of the technical side of the project and was also the technical contact for any technical questions. He was also in charge of allocating tasks and organizing sprints.

As for the code, it was managed via a versioning system, \gls{BitBucket}, which manages different versions of the code, branches, pull requests to validate modifications and conflicts, much like Github. Here, a task was synonymous with features to be implemented, so a branch was created for each task and a pull request was created for each branch. The pull request was then validated when the task was finished and the code was functional. This made it possible to keep a history of modifications, validate them and integrate them into the main code without the risk of breaking existing code.

To test the code on the target, we had to connect to a remote PC, as it was physically located in Germany.
\subsection{Effective work}

\subsubsection{Build Configuration}

The first task was a duo with my tutor, to find the right configuration for the build process in order to activate the OP-TEE OS integration as well as the secure boot proposed by the TF-A.
\\For the record, the project target comprised several SoMs. Our mission focused solely on one SoM, which was made up of two SoCs.One was a Cortex-A53 processor, the other a Cortex-R processor. These SoCs communicate with each other, and even separate the cores of the Cortex-A53 processor. In other words, we have 2 cores used for Linux and the other two for a \gls{RTOS}. The other SoC, made up of a Cortex-R, was running another RTOS.

\begin{figure}[H]
    \centering
    \includegraphics[width=0.9\textwidth]{images/indus_board_archi.png}
    \caption{Secure Key Storage application architecture}
    \label{fig:SECURE-LOGS-ARCHI}
\end{figure}

This embedded system has a very complex hardware architecture, which is also reflected in the software, notably in the build process supplied by the manufacturer, thanks to a very extensive \gls{BSP} and \gls{SDK}, and modified by the customer to add specific functionalities.

\begin{notes}
    \item In essence, the BSP is concerned with making the hardware operational and providing a foundation for the operating system, while the SDK provides the tools and resources needed for application development on that platform.
\end{notes}

What we can retain is that this build process was made up of 3 BitBucket repo:
\begin{itemize}
    \item \textbf{\texttt{linux}} : to build a binary containing the linux kernel and its File System using the \gls{BuildRoot} tool (similar to Yocto Project).
    \item \textbf{\texttt{cortex\_r}} : to build the Cortex-R Soc banary using Makefile and scripts.
    \item \textbf{\texttt{cortex\_a}} : to build the RTOS binary running on the Cortex-A using Makefiles and scripts. But also to compile all the binaries built so far into a single flashable image for the target.
\end{itemize}

All this is linked by a general build script contained in the \textbf{\texttt{cortex\_a}} repo, which is used to call up the various stages of build.d.

So the first step was to understand how the build process worked, how the files were organized, with the configurations. To do this, we had to read the documentation provided by the manufacturer, read the documentation provided by the customer, and unravel the whole thing with the sources we had. It took about 1 week to understand how everything was organized and how it all worked. It was very difficult because the documentation was very limited and the scripts and Makefiles very complex. In addition, the customer had modified certain aspects of the code, forgetting to provide precise documentation on the changes made.
\\Once we'd got to know the project and set it up on our respective computers, we were able to start work on integrating OP-TEE OS.

The BSP supplied is not for a single target in particular, but directly for several different manufacturer targets with different characteristics and layouts. So, in order to build the image for a particular system, everything goes through build variables which are defined in several configuration files. So we had to find the right variables to modify.
\\Firstly, it was the BuildRoot side, which contains the OP-TEE sources (OS, Client, test, etc.) that we modified. All we had to do was integrate the OP-TEE packages into the BuildRoot configuration file and it would be built with everything else. This produced an OP-TEE OS binary in addition to the Linux binary and File System. Now came the hard part for cortex\_r and cortex\_a. The cortex\_a build is a little more complex, not only because it's based on raw Makefiles, but also because this is where everything is linked together, from memory layout and partitioning to the choice of binaries to be used in the final image and TF-A build. This is the cornerstone of the project. This stage was very poorly documented, if at all, which meant that it took us several weeks to gradually understand what the right configurations were. We had to arrange several meetings with the manufacturer's expers to help us understand the BSP, and we had to run tests on the target to see if the modifications made were correct. It was very long and fastidious, but we eventually found the right configurations and the image was built correctly.

\subsubsection{Secure Key TA}
One of the reasons for integrating OP-TEE was its Secure Storage function. Indeed, several cryptographic keys from different security bricks needed to be stored securely. To achieve this, a \gls{Trusted Application} was created to store these keys. This TA would enable keys to be stored as well as retrieved. To begin with, the first version of the TA was designed to store any data with its storage ID. It then took the form of the application designed to store logs seen earlier in this report (see section \ref{sec:SECURE-LOGS}).

\begin{figure}[H]
    \centering
    \includegraphics[width=0.9\textwidth]{images/secure_key_v1.png}
    \caption{Secure Key Storage application architecture}
    \label{fig:SECURE-LOGS-ARCHI}
\end{figure}

Here, Linux doesn't have direct access to persistent storage (an eMMC), but passes through the Cortex-A RTOS, which is the only way to access it. A totally transparent abstraction has been made by the client so that Linux can access the storage as if it had direct access via a path in its File System. This is important because here Linux has no access to persistent storage, as everything is stored in RAM, which is volatile.
\\The TA is therefore called by Linux to store or retrieve keys. The TA then stores the keys, encrypting and signing them to guarantee their integrity. A client has also been created for Linux. This client allows you to store or retrieve keys by calling commands from the TA via the OP-TEE Client API.
For easier testing, I used the IMX8 from the previous project, which I had directly on my physical desktop. Only the specification version was different, but that didn't pose much of a problem apart from a slightly different function signature. This saved me time, as I didn't have to find the right slot to connect to the target in Germany to test the code. For the final installation on the target, I took the BuildRoot package from \texttt{optee-example} as an example and created my own package to compile and install the various TAs that would be used for this project. BuildRoot packages are relatively similar to Yocto recipes. Just define the sources, dependencies, build and install commands and that's it. 
\\Now that this base had been created, it was easier for another member of the team to continue developing other TAs to be used for other functionalities such as cryptographic calculation execution or encryption key management and verification.


\subsubsection{Inter processors communication}
Now, the task was to understand how inter-processor communication (IPC) was achieved. In fact, there are already applications communicating between the various processors, and an API is provided by the manufacturer in the SDK. So we had to understand how this was done to be able to implement communication between the Cortex-A RTOS and Linux. In fact, the TA storing the keys was called by Linux but had to retrieve the keys used by the Cortex-A RTOS. In fact, most of the keys were used by the RTOS and only a few by Linux.

The SDK includes an API based on a technology that enables inter-processor communication, including : \gls{RPMsg} and IPC application over RPMsg proposed by \gls{OpenAMP}. This means that the two processors can communicate with each other via messages, or run programs on other processors with parameters and feedback. This is possible because the processors have access to a shared memory and can send interrupts to the other processor to signal that a message has been written to the shared memory.

\begin{figure}[H]
    \centering
    \includegraphics[width=0.5\textwidth]{images/core_to_core_interrupt.jpg}
    \caption{Core to Core communication (Image Credit: OpenAMP)}
    \label{fig:C-to-C-COM}
\end{figure}

The aim here was to implement an IPC application over RPMsg. It works on a client-server schema with a protocol overlay based on \gls{Remote Procedure Call}. Each IPC application uses a unique RPMsg channel to communicate. These channels and their allocation are managed on the Linux side by an RPMsg server, which allocates a channel to each application IPC. The server converts RPC program numbers into universal addresses. It must be running on Linux to be able to make RPC calls on a server for that machine. When the RPC service starts, it tells the server the address at which it is listening, and the RPC program numbers it is preparing to serve. When a client wishes to make an RPC call to a given program number, it first contacts the server on the server machine to determine the address where RPC requests should be sent.

Here's the architecture for our use of this technology:
\begin{figure}[H]
    \centering
    \includegraphics[width=1\textwidth]{images/ipc-archi.png}
    \caption{TA invokation via IPC architecture}
    \label{fig:C-to-C-COM}
\end{figure}

At this point, only a service to invoke the TA secure storage commands had been implemented. The aim was also to provide all team members with a basis and example on which to build their own IPC services connected to other features offered by a TA. 

\subsubsection{Team support}
The end of the project was dedicated to supporting the other team members in their tasks. This included helping them to understand how OP-TEE and the APIs work for them to write and implement their own TAs, but also the IPC technology and how to use it to communicate between their applications running on the Cortex-A RTOS and trusted applications. A technical discussion was also held to think about the best way to manage all the limitations of these technologies.



\subsection{Critical opinion}

Ce projet à été très instructif

\section*{Conclusion}
\subsection*{Outcome}
Bilan final du stage.
\subsection*{Perspectives}
Perspectives d'avenir pour le monde de l'embarqué + pour moi + pour moi dans le monde de l'embarqué.



\clearpage

\printnoidxglossaries
\printbibliography
\end{document}

